<?php
require("ts3admin.class.php");
	$serverCount=0;
	$slotCount=0;	
	$tsAdmin = new ts3admin($ts3_ip, $ts3_queryport);
	$tsAdmin->connect();
	$tsAdmin->login($ts3_user, $ts3_pass);
	$result = $tsAdmin->serverList();
	if(!$result['success'])
	{
		echo "Ein Fehler ist aufgetreten: ".$result['errors'][0];
	}
	else
	{
		echo '<table border=1>';
		echo '<tr><td>Name</td><td>Slots</td><td>luft</td></tr>';
		foreach($result['data'] as $server) 
		{
			if($server['virtualserver_status']=='online')
			{
				if($server['virtualserver_uptime']>=($ttl*3600) && $server['virtualserver_port']!=$ts3_port) $tsAdmin->serverDelete($server['virtualserver_id']);
				else
				{
					echo '<tr><td>'.$server['virtualserver_name'].'</td>';
					echo '<td>'.$server['virtualserver_maxclients'].'</td>';
					echo '<td>'.number_format(($server['virtualserver_uptime']/60/60),2).'/'.number_format($ttl,2).' Stunden</td></tr>';
					$serverCount++;
					$slotCount+=$server['virtualserver_maxclients'];
				}
			}
		}
		echo '</table>';
	}
	
	if(isset($_POST['name']) and isset($_POST['slots']))
	{
		if($_POST['slots']+$slotCount>512 || $serverCount>=10) die('alle Server vergeben!');
		if($_POST['slots']>50) die('Wir vergeben nur 50 Slot Server!');
		$tsAdmin = new ts3admin($ts3_ip, $ts3_queryport);
		$tsAdmin->connect();
		$tsAdmin->login($ts3_user, $ts3_pass);
		$data = array(
			'virtualserver_name' => $_POST['name'],
			'virtualserver_maxclients' => $_POST['slots'],
			'virtualserver_weblist_enabled' => '1',
			'virtualserver_log_client' => '1',
			'virtualserver_log_query' => '1',
			'virtualserver_log_channel' => '1',
			'virtualserver_log_permission' => '1',
			'virtualserver_log_server' => '1',
			'virtualserver_log_filetransfer' => '1',
			'virtualserver_hostbanner_url' => '',
			'virtualserver_hostbanner_gfx_url' => '',
			'virtualserver_hostbutton_url' => '',
			'virtualserver_hostbutton_gfx_url' => '',
			'virtualserver_hostbutton_tooltip' => '',
			'virtualserver_download_quota' => '-1',
			'virtualserver_upload_quota' => '-1',
			'virtualserver_max_download_total_bandwidth' => '-1',
			'virtualserver_max_upload_total_bandwidth' => '-1',
			'virtualserver_codec_encryption_mode' => 0, //0=einstellbar 1=aus 2=aus (opt_codec+1)
		);
		$result = $tsAdmin->serverCreate($data);
		if(!$result['success'])
		{
			echo "Ein Fehler ist aufgetreten: ".$result['errors'][0];
		}
		else
		{
			echo '<br><br>Dein Server luft unter: <a href="ts3server://'.$ts3_ip.':'.$result['data']['virtualserver_port'].'">'.$ts3_ip.':'.$result['data']['virtualserver_port'].'</a><br>';
			echo "Dein token lautet:<br><br><b>".$result['data']['token'].'</b>';
		}
	}
	else
	{
		echo '<br><br>Es sein noch '.(10-$serverCount).' Server mit insgesammt '.(512-$slotCount).' Slots frei!<br><br>';
		?>
		<table>
			<form action = "createServer.php" method="POST">
			<tr><td>Name:</td> <td><input type="text" name="name"></td></tr>
			<tr><td>Slots:</td> <td><select name="slots">
			<?php for($i=5;$i<=50;$i=$i+5) { if($i<(512-$slotCount)) echo '<option value="'.$i.'">'.$i.'</option>'; } ?>
			</select><td></tr>
		</table></br>
		<input type="submit" value="Server erstellen"></p>
		</form>
		
	<?php
	}
?>